Index: issm/trunk/src/c/Makefile.am
===================================================================
--- issm/trunk/src/c/Makefile.am	(revision 23389)
+++ issm/trunk/src/c/Makefile.am	(revision 23394)
@@ -1,3 +1,3 @@
-AM_CPPFLAGS = @NEOPZINCL@ @DAKOTAINCL@ @SHAPELIBINCL@ @PETSCINCL@ @SLEPCINCL@ @AMPIINCL@ @MPIINCL@ @METISINCL@ @CHACOINCL@ @SCOTCHINCL@ @PLAPACKINCL@ @BLASLAPACKINCL@ @MKLINCL@ @MUMPSINCL@ @TRIANGLEINCL@ @SPAIINCL@ @HYPREINCL@ @PROMETHEUSINCL@ @SUPERLUINCL@ @SPOOLESINCL@ @PASTIXINCL@ @MLINCL@ @TAOINCL@ @ADIC2INCL@ @ADOLCINCL@ @GSLINCL@ @BOOSTINCL@ @ANDROID_NDKINCL@ @METEOIOINCL@ @SNOWPACKINCL@ @PROJ4INCL@
+AM_CPPFLAGS = @NEOPZINCL@ @DAKOTAINCL@ @SHAPELIBINCL@ @PETSCINCL@ @SLEPCINCL@ @AMPIINCL@ @ADJOINTMPIINCL@ @MEDIPACKINCL@ @MPIINCL@ @METISINCL@ @CHACOINCL@ @SCOTCHINCL@ @PLAPACKINCL@ @BLASLAPACKINCL@ @MKLINCL@ @MUMPSINCL@ @TRIANGLEINCL@ @SPAIINCL@ @HYPREINCL@ @PROMETHEUSINCL@ @SUPERLUINCL@ @SPOOLESINCL@ @PASTIXINCL@ @MLINCL@ @TAOINCL@ @ADIC2INCL@ @ADOLCINCL@ @CODIPACKINCL@ @GSLINCL@ @BOOSTINCL@ @ANDROID_NDKINCL@ @METEOIOINCL@ @SNOWPACKINCL@ @PROJ4INCL@
 
 AUTOMAKE_OPTIONS = subdir-objects
@@ -51,8 +51,11 @@
 					 ./modules/BamgTriangulatex/BamgTriangulatex.cpp
 
-#do not include AmrBamg with ADOLC
+#do not include AmrBamg with AD
 if ADOLC
 else
+if CODIPACK
+else
 issm_sources += ./classes/AmrBamg.cpp
+endif
 endif
 endif
@@ -172,4 +175,5 @@
 					./shared/Elements/PrintArrays.cpp\
 					./shared/Elements/PddSurfaceMassBalance.cpp\
+					./shared/Elements/PddSurfaceMassBalanceSicopolis.cpp\
 					./shared/Elements/ComputeDelta18oTemperaturePrecipitation.cpp\
 					./shared/Elements/ComputeMungsmTemperaturePrecipitation.cpp\
@@ -320,4 +324,12 @@
 					./classes/Inputs/TetraInput.cpp
 #}}}
+#ADJOINTMPI/MeDiPack sources {{{
+if ADJOINTMPI
+issm_sources += ./toolkits/codipack/ampi_interface.cpp
+endif
+if MEDIPACK
+issm_sources += ./toolkits/codipack/ampi_interface.cpp
+endif
+# }}}
 #DAKOTA sources  {{{
 if DAKOTA
@@ -632,5 +644,5 @@
 if !WINDOWS
 if !STANDALONE_LIBRARIES
-libISSMCore_la_LIBADD = $(PETSCLIB) $(TAOLIB) $(M1QN3LIB) $(PLAPACKLIB) $(MUMPSLIB) $(SUPERLULIB) $(SPOOLESLIB) $(SCALAPACKLIB) $(BLACSLIB) $(HYPRELIB) $(SPAILIB) $(PROMETHEUSLIB) $(PASTIXLIB) $(MLLIB) $(DAKOTALIB) $(METISLIB) $(CHACOLIB) $(SCOTCHLIB) $(BLASLAPACKLIB) $(MKLLIB) $(MPILIB) $(MATHLIB) $(GRAPHICSLIB) $(MULTITHREADINGLIB) $(OSLIBS) $(GSLLIB)   $(ADOLCLIB) $(AMPILIB) $(METEOIOLIB) $(SNOWPACKLIB)
+libISSMCore_la_LIBADD = $(PETSCLIB) $(TAOLIB) $(M1QN3LIB) $(PLAPACKLIB) $(MUMPSLIB) $(SUPERLULIB) $(SPOOLESLIB) $(SCALAPACKLIB) $(BLACSLIB) $(HYPRELIB) $(SPAILIB) $(PROMETHEUSLIB) $(PASTIXLIB) $(MLLIB) $(DAKOTALIB) $(METISLIB) $(CHACOLIB) $(SCOTCHLIB) $(BLASLAPACKLIB) $(MKLLIB) $(MPILIB) $(MATHLIB) $(GRAPHICSLIB) $(MULTITHREADINGLIB) $(OSLIBS) $(GSLLIB)   $(ADOLCLIB) $(AMPILIB) $(ADJOINTMPILIB) $(METEOIOLIB) $(SNOWPACKLIB)
 if FORTRAN
 libISSMCore_la_LIBADD += $(FLIBS) $(FORTRANLIB)
@@ -714,5 +726,5 @@
 
 #External packages
-LDADD +=  $(NEOPZLIB) $(TAOLIB) $(M1QN3LIB) $(PLAPACKLIB) $(MUMPSLIB) $(SUPERLULIB) $(SPOOLESLIB) $(SCALAPACKLIB) $(BLACSLIB) $(PETSCLIB) $(HYPRELIB) $(SPAILIB) $(PROMETHEUSLIB) $(PASTIXLIB) $(MLLIB) $(DAKOTALIB) $(METISLIB) $(CHACOLIB) $(SCOTCHLIB) $(BLASLAPACKLIB) $(MKLLIB) $(MPILIB)  $(MATHLIB) $(GRAPHICSLIB) $(MULTITHREADINGLIB) $(OSLIBS) $(GSLLIB) $(AMPILIB) $(ADOLCLIB) $(MPILIB) $(METEOIOLIB) $(SNOWPACKLIB) $(PROJ4LIB)
+LDADD +=  $(NEOPZLIB) $(TAOLIB) $(M1QN3LIB) $(PLAPACKLIB) $(MUMPSLIB) $(SUPERLULIB) $(SPOOLESLIB) $(SCALAPACKLIB) $(BLACSLIB) $(PETSCLIB) $(HYPRELIB) $(SPAILIB) $(PROMETHEUSLIB) $(PASTIXLIB) $(MLLIB) $(DAKOTALIB) $(METISLIB) $(CHACOLIB) $(SCOTCHLIB) $(BLASLAPACKLIB) $(MKLLIB) $(MPILIB)  $(MATHLIB) $(GRAPHICSLIB) $(MULTITHREADINGLIB) $(OSLIBS) $(GSLLIB) $(AMPILIB) $(ADJOINTMPILIB) $(ADOLCLIB) $(MPILIB) $(METEOIOLIB) $(SNOWPACKLIB) $(PROJ4LIB)
 
 if FORTRAN
Index: issm/trunk/src/c/analyses/EnthalpyAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/EnthalpyAnalysis.cpp	(revision 23389)
+++ issm/trunk/src/c/analyses/EnthalpyAnalysis.cpp	(revision 23394)
@@ -43,6 +43,7 @@
 		int smb_model;
 		iomodel->FindConstant(&smb_model,"md.smb.model");
-		if(smb_model==SMBpddEnum)     isdynamic=true;
-		if(smb_model==SMBd18opddEnum) isdynamic=true;
+		if(smb_model==SMBpddEnum)				isdynamic=true;
+		if(smb_model==SMBd18opddEnum)			isdynamic=true;
+		if(smb_model==SMBpddSicopolisEnum)	isdynamic=true;
 	}
 
@@ -1200,4 +1201,6 @@
 		_assert_((Hc+Ht)>0.);
 		lambda = Hc/(Hc+Ht);
+		_assert_(lambda>=0.);
+		_assert_(lambda<=1.);
 		kappa  = kappa_c*kappa_t/(lambda*kappa_t+(1.-lambda)*kappa_c); // ==(lambda/kappa_c + (1.-lambda)/kappa_t)^-1
 	}	
Index: issm/trunk/src/c/analyses/ExtrapolationAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/ExtrapolationAnalysis.cpp	(revision 23389)
+++ issm/trunk/src/c/analyses/ExtrapolationAnalysis.cpp	(revision 23394)
@@ -65,5 +65,5 @@
 	femmodel->SetCurrentConfiguration(ExtrapolationAnalysisEnum);
 
-	if(VerboseSolution()) _printf0_("extrapolation of " << EnumToStringx(extvar_enum) << ": call computational core:\n");
+	if(VerboseSolution()) _printf0_("   extrapolation of " << EnumToStringx(extvar_enum) << ":\n");
 	solutionsequence_linear(femmodel);
 
Index: issm/trunk/src/c/analyses/FreeSurfaceBaseAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/FreeSurfaceBaseAnalysis.cpp	(revision 23389)
+++ issm/trunk/src/c/analyses/FreeSurfaceBaseAnalysis.cpp	(revision 23394)
@@ -80,5 +80,4 @@
 	iomodel->FetchDataToInput(elements,"md.mask.ice_levelset",MaskIceLevelsetEnum);
 	iomodel->FetchDataToInput(elements,"md.basalforcings.groundedice_melting_rate",BasalforcingsGroundediceMeltingRateEnum,0.);
-	iomodel->FetchDataToInput(elements,"md.basalforcings.floatingice_melting_rate",BasalforcingsFloatingiceMeltingRateEnum);
 	iomodel->FetchDataToInput(elements,"md.initialization.vx",VxEnum);
 	iomodel->FetchDataToInput(elements,"md.initialization.vy",VyEnum);
@@ -89,4 +88,29 @@
 		iomodel->FetchDataToInput(elements,"md.mesh.vertexonbase",MeshVertexonbaseEnum);
 		iomodel->FetchDataToInput(elements,"md.mesh.vertexonsurface",MeshVertexonsurfaceEnum);
+	}
+
+	/*Get what we need for ocean-induced basal melting*/
+	int basalforcing_model;
+	iomodel->FindConstant(&basalforcing_model,"md.basalforcings.model");
+	switch(basalforcing_model){
+		case FloatingMeltRateEnum:
+			iomodel->FetchDataToInput(elements,"md.basalforcings.floatingice_melting_rate",BasalforcingsFloatingiceMeltingRateEnum);
+			break;
+		case LinearFloatingMeltRateEnum:
+			break;
+		case MismipFloatingMeltRateEnum:
+			break;
+		case MantlePlumeGeothermalFluxEnum:
+			break;
+		case SpatialLinearFloatingMeltRateEnum:
+			iomodel->FetchDataToInput(elements,"md.basalforcings.deepwater_melting_rate",BasalforcingsDeepwaterMeltingRateEnum);
+			iomodel->FetchDataToInput(elements,"md.basalforcings.deepwater_elevation",BasalforcingsDeepwaterElevationEnum);
+			iomodel->FetchDataToInput(elements,"md.basalforcings.upperwater_elevation",BasalforcingsUpperwaterElevationEnum);
+			break;
+		case BasalforcingsPicoEnum:
+			iomodel->FetchDataToInput(elements,"md.basalforcings.basin_id",BasalforcingsPicoBasinIdEnum);
+			break;
+		default:
+			_error_("Basal forcing model "<<EnumToStringx(basalforcing_model)<<" not supported yet");
 	}
 }/*}}}*/
Index: issm/trunk/src/c/analyses/HydrologyDCEfficientAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/HydrologyDCEfficientAnalysis.cpp	(revision 23389)
+++ issm/trunk/src/c/analyses/HydrologyDCEfficientAnalysis.cpp	(revision 23394)
@@ -313,12 +313,14 @@
 	}
 	/*Intermediaries */
+	int        smb_model;
 	IssmDouble dt,scalar,water_head;
-	IssmDouble water_load,transfer;
+	IssmDouble water_load,transfer,runoff_value;
 	IssmDouble epl_storing,epl_transmitivity;
 	IssmDouble Jdet;
 	IssmDouble residual,connectivity;
 
-	IssmDouble *xyz_list     = NULL;
-	Input*      old_wh_input = NULL;
+	IssmDouble		*xyz_list							= NULL;
+	Input*				 old_wh_input					= NULL;
+	Input*				 surface_runoff_input = NULL;
 
 	/*Fetch number of nodes and dof for this finite element*/
@@ -334,15 +336,20 @@
 	//basalelement->FindParam(&dt,TimesteppingTimeStepEnum);
 	basalelement ->FindParam(&dt,HydrologydtEnum);
-
-	Input* epl_thick_input = basalelement->GetInput(HydrologydcEplThicknessHydrostepEnum); _assert_(epl_thick_input);
-	Input* sed_head_input  = basalelement->GetInput(SedimentHeadHydrostepEnum); _assert_(sed_head_input);
-	Input* epl_head_input	 = basalelement->GetInput(EplHeadHydrostepEnum); _assert_(epl_head_input);
-	Input* water_input		 = basalelement->GetInput(BasalforcingsGroundediceMeltingRateEnum); _assert_(water_input);
-	Input* residual_input  = basalelement->GetInput(SedimentHeadResidualEnum); _assert_(residual_input);
-	Input* base_input			 = basalelement->GetInput(BaseEnum); _assert_(base_input);
+	basalelement ->FindParam(&smb_model,SmbEnum);
+
+	Input*	epl_thick_input			 = basalelement->GetInput(HydrologydcEplThicknessHydrostepEnum); _assert_(epl_thick_input);
+	Input*	sed_head_input			 = basalelement->GetInput(SedimentHeadHydrostepEnum); _assert_(sed_head_input);
+	Input*	epl_head_input			 = basalelement->GetInput(EplHeadHydrostepEnum); _assert_(epl_head_input);
+	Input*	basal_melt_input		 = basalelement->GetInput(BasalforcingsGroundediceMeltingRateEnum); _assert_(basal_melt_input);
+	Input*	residual_input			 = basalelement->GetInput(SedimentHeadResidualEnum); _assert_(residual_input);
+	Input*	base_input					 = basalelement->GetInput(BaseEnum); _assert_(base_input);
 
 	if(dt!= 0.){
 		old_wh_input = basalelement->GetInput(EplHeadOldEnum);            _assert_(old_wh_input);
 	}
+	if(smb_model==SMBgradientscomponentsEnum){
+		surface_runoff_input = basalelement->GetInput(SmbRunoffEnum); _assert_(surface_runoff_input);
+	}
+
 	/* Start  looping on the number of gaussian points: */
 	Gauss* gauss           = basalelement->NewGauss(2);
@@ -355,6 +362,8 @@
 
 		/*Loading term*/
-		water_input->GetInputValue(&water_load,gauss);
-		scalar = Jdet*gauss->weight*(water_load);
+		basal_melt_input->GetInputValue(&water_load,gauss);
+		if(surface_runoff_input) surface_runoff_input->GetInputValue(&runoff_value,gauss);
+		else                     runoff_value = 0.;
+		scalar = Jdet*gauss->weight*(water_load+runoff_value);
 		//scalar = Jdet*gauss->weight*(water_load)/epl_transmitivity;
 		if(dt!=0.) scalar = scalar*dt;
@@ -524,4 +533,5 @@
 	IssmDouble  EPLgrad2;
 	IssmDouble  EPL_N;
+	IssmDouble  opening,closing;
 
 	femmodel->parameters->FindParam(&domaintype,DomainTypeEnum);
@@ -589,7 +599,12 @@
 				EPLgrad2 = (epl_slopeX[i]*epl_slopeX[i])+(epl_slopeY[i]*epl_slopeY[i]);
 				/*And proceed to the real thing*/
-				thickness[i] = old_thickness[i]/(1.0
-																				 -((rho_water*gravity*epl_conductivity*EPLgrad2*dt)/(rho_ice*latentheat))
-																				 +((2.0*A*dt*pow(EPL_N,n))/(pow(n,n))));
+				opening=(rho_water*gravity*epl_conductivity*EPLgrad2*dt)/(rho_ice*latentheat);
+				closing=(2.0*A*dt*pow(EPL_N,n))/(pow(n,n));
+				/*implicit*/
+				thickness[i] = old_thickness[i]/(1.0-opening+closing);
+				/*explicit*/
+				//thickness[i] = old_thickness[i]*(1.0+opening-closing);
+				/*centered*/
+				//thickness[i] = old_thickness[i]*(1.0+opening-closing)/(1.0-opening+closing);
 				/*Take care of otherthikening*/
 				if(thickness[i]>max_thick){
@@ -688,24 +703,20 @@
 		if(old_active[i]>0.){
 			vec_mask->SetValue(basalelement->nodes[i]->Sid(),1.,INS_VAL);
-			/* If epl thickness gets under colapse thickness, close the layer */
-			if(epl_thickness[i]<colapse_thick){
+			/* If epl thickness gets under colapse thickness, close the layer if there is no residual*/
+			if(epl_thickness[i]<colapse_thick && residual[i]<=0.){
 				vec_mask->SetValue(basalelement->nodes[i]->Sid(),0.,INS_VAL);
 				recurence->SetValue(basalelement->nodes[i]->Sid(),1.,INS_VAL);
 			}
-			/* //If epl head gets under base elevation, close the layer */
-			/* else if(eplhead[i]<(base[i]-1.0e-8)){ */
-			/* 	vec_mask->SetValue(basalelement->nodes[i]->Sid(),0.,INS_VAL); */
-			/* 	recurence->SetValue(basalelement->nodes[i]->Sid(),1.,INS_VAL); */
-			/* } */
-		}
-		/*If node is now closed bring its thickness back to initial*/
+		}
 		if (old_active[i]==0.){
-			epl_thickness[i]=init_thick;
 			/*Activate if we have a residual from sediment*/
 			if(residual[i]>0.){
 				vec_mask->SetValue(basalelement->nodes[i]->Sid(),1.,INS_VAL);
-				if(old_active[i]==0.){
-					recurence->SetValue(basalelement->nodes[i]->Sid(),1.,INS_VAL);
-				}
+				recurence->SetValue(basalelement->nodes[i]->Sid(),1.,INS_VAL);
+			}
+			else{
+				/*If node is now closed bring its thickness back to initial*/
+				epl_thickness[i]=init_thick;
+				vec_mask->SetValue(basalelement->nodes[i]->Sid(),0.,INS_VAL);
 			}
 		}
Index: issm/trunk/src/c/analyses/HydrologyDCInefficientAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/HydrologyDCInefficientAnalysis.cpp	(revision 23389)
+++ issm/trunk/src/c/analyses/HydrologyDCInefficientAnalysis.cpp	(revision 23394)
@@ -10,5 +10,4 @@
 	return 1;
 }/*}}}*/
-
 void HydrologyDCInefficientAnalysis::UpdateParameters(Parameters* parameters,IoModel* iomodel,int solution_enum,int analysis_enum){/*{{{*/
 
@@ -29,4 +28,6 @@
 
 	/*retrieve some parameters: */
+	bool   issmb;
+	iomodel->FindConstant(&issmb,"md.transient.issmb");
 	iomodel->FindConstant(&hydrology_model,"md.hydrology.model");
 
@@ -63,4 +64,8 @@
 		parameters->AddObject(new DoubleParam(HydrologydcSedimentlimitEnum,sedimentlimit));
 	}
+	if(!issmb){
+		parameters->AddObject(iomodel->CopyConstantObject("md.smb.model",SmbEnum));
+	}
+
   /*Requested outputs*/
   iomodel->FindConstant(&requestedoutputs,&numoutputs,"md.hydrology.requested_outputs");
@@ -69,5 +74,4 @@
   iomodel->DeleteData(&requestedoutputs,numoutputs,"md.hydrology.requested_outputs");
 }/*}}}*/
-
 void HydrologyDCInefficientAnalysis::UpdateElements(Elements* elements,IoModel* iomodel,int analysis_counter,int analysis_type){/*{{{*/
 
@@ -105,11 +109,10 @@
 		iomodel->FetchDataToInput(elements,"md.mesh.vertexonsurface",MeshVertexonsurfaceEnum);
 	}
-
 	if(isefficientlayer){
 		iomodel->FetchDataToInput(elements,"md.hydrology.mask_eplactive_node",HydrologydcMaskEplactiveNodeEnum);
 		iomodel->FetchDataToInput(elements,"md.initialization.epl_head",EplHeadHydrostepEnum);
 	}
-}/*}}}*/
-
+
+}/*}}}*/
 void HydrologyDCInefficientAnalysis::CreateNodes(Nodes* nodes,IoModel* iomodel){/*{{{*/
 
@@ -127,5 +130,4 @@
 	iomodel->DeleteData(2,"md.mesh.vertexonbase","md.mesh.vertexonsurface");
 }/*}}}*/
-
 void HydrologyDCInefficientAnalysis::CreateConstraints(Constraints* constraints,IoModel* iomodel){/*{{{*/
 
@@ -137,5 +139,4 @@
 	IoModelToConstraintsx(constraints,iomodel,"md.hydrology.spcsediment_head",HydrologyDCInefficientAnalysisEnum,P1Enum);
 }/*}}}*/
-
 void HydrologyDCInefficientAnalysis::CreateLoads(Loads* loads, IoModel* iomodel){/*{{{*/
 
@@ -172,14 +173,11 @@
 	_error_("not implemented");
 }/*}}}*/
-
 ElementVector* HydrologyDCInefficientAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
 	return NULL;
 }/*}}}*/
-
 ElementMatrix* HydrologyDCInefficientAnalysis::CreateJacobianMatrix(Element* element){/*{{{*/
 _error_("Not implemented");
 }/*}}}*/
-
 ElementMatrix* HydrologyDCInefficientAnalysis::CreateKMatrix(Element* element){/*{{{*/
 
@@ -307,5 +305,4 @@
 	return Ke;
 }/*}}}*/
-
 ElementVector* HydrologyDCInefficientAnalysis::CreatePVector(Element* element){/*{{{*/
 
@@ -342,12 +339,14 @@
 	/*Intermediaries */
 	bool       active_element,isefficientlayer;
+	int        smb_model;
 	IssmDouble dt,scalar,sediment_storing;
 	IssmDouble water_head,sediment_transmitivity;
-	IssmDouble water_load,transfer;
+	IssmDouble water_load,runoff_value,transfer;
 	IssmDouble Jdet;
 
 	IssmDouble *xyz_list             = NULL;
 	Input*      active_element_input = NULL;
-	Input*      old_wh_input = NULL;
+	Input*      old_wh_input         = NULL;
+	Input*      surface_runoff_input = NULL;
 
 	/*Fetch number of nodes and dof for this finite element*/
@@ -361,16 +360,21 @@
 	basalelement->GetVerticesCoordinates(&xyz_list);
 	//basalelement->FindParam(&dt,TimesteppingTimeStepEnum);
-	basalelement ->FindParam(&dt,HydrologydtEnum);
+	basalelement->FindParam(&dt,HydrologydtEnum);
 	basalelement->FindParam(&isefficientlayer,HydrologydcIsefficientlayerEnum);
-
-	Input* sed_head_input = basalelement->GetInput(SedimentHeadHydrostepEnum);
-	Input* epl_head_input = basalelement->GetInput(EplHeadHydrostepEnum);
-	Input* base_input		  = basalelement->GetInput(BaseEnum);
-	Input* water_input	  = basalelement->GetInput(BasalforcingsGroundediceMeltingRateEnum); _assert_(water_input);
-	Input* SedTrans_input = basalelement->GetInput(HydrologydcSedimentTransmitivityEnum); _assert_(SedTrans_input);
+	basalelement->FindParam(&smb_model,SmbEnum);
+
+	Input*	sed_head_input			 = basalelement->GetInput(SedimentHeadHydrostepEnum);
+	Input*	epl_head_input			 = basalelement->GetInput(EplHeadHydrostepEnum);
+	Input*	base_input					 = basalelement->GetInput(BaseEnum);
+	Input*	basal_melt_input		 = basalelement->GetInput(BasalforcingsGroundediceMeltingRateEnum); _assert_(basal_melt_input);
+	Input*	SedTrans_input			 = basalelement->GetInput(HydrologydcSedimentTransmitivityEnum); _assert_(SedTrans_input);
 
 	if(dt!= 0.){
 		old_wh_input = basalelement->GetInput(SedimentHeadOldEnum);                  _assert_(old_wh_input);
 	}
+	if(smb_model==SMBgradientscomponentsEnum){
+		surface_runoff_input = basalelement->GetInput(SmbRunoffEnum); _assert_(surface_runoff_input);
+	}
+
 	/*Transfer related Inputs*/
 	if(isefficientlayer){
@@ -388,6 +392,8 @@
 		/*Loading term*/
 		if(!isefficientlayer){
-			water_input->GetInputValue(&water_load,gauss);
-			scalar = Jdet*gauss->weight*(water_load);
+			basal_melt_input->GetInputValue(&water_load,gauss);
+			if(surface_runoff_input) surface_runoff_input->GetInputValue(&runoff_value,gauss);
+			else                     runoff_value = 0.;
+			scalar = Jdet*gauss->weight*(water_load+runoff_value);
 			//scalar = Jdet*gauss->weight*(water_load)/sediment_transmitivity;
 			if(dt!=0.) scalar = scalar*dt;
@@ -400,6 +406,8 @@
 			active_element_input->GetInputValue(&active_element);
 			if(!active_element){
-				water_input->GetInputValue(&water_load,gauss);
-				scalar = Jdet*gauss->weight*(water_load);
+				basal_melt_input->GetInputValue(&water_load,gauss);
+				if(surface_runoff_input) surface_runoff_input->GetInputValue(&runoff_value,gauss);
+				else                     runoff_value = 0.;
+				scalar = Jdet*gauss->weight*(water_load+runoff_value);
 				//scalar = Jdet*gauss->weight*(water_load)/sediment_transmitivity;
 				if(dt!=0.) scalar = scalar*dt;
@@ -444,5 +452,4 @@
 	return pe;
 }/*}}}*/
-
 void HydrologyDCInefficientAnalysis::GetB(IssmDouble* B,Element* element,IssmDouble* xyz_list,Gauss* gauss){/*{{{*/
 	/*Compute B  matrix. B=[B1 B2 B3] where Bi is of size 3*NDOF2.
@@ -472,13 +479,10 @@
 	xDelete<IssmDouble>(dbasis);
 }/*}}}*/
-
 void HydrologyDCInefficientAnalysis::GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element){/*{{{*/
 	element->GetSolutionFromInputsOneDof(solution,SedimentHeadHydrostepEnum);
 }/*}}}*/
-
 void HydrologyDCInefficientAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
 	_error_("Not implemented yet");
 }/*}}}*/
-
 void HydrologyDCInefficientAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
 
@@ -514,5 +518,4 @@
 	/*Use the dof list to index into the solution vector: */
 
-	/*need to introduce thawed test herre*/
 	for(int i=0;i<numnodes;i++){
 		values[i] =solution[doflist[i]];
@@ -542,5 +545,13 @@
 		kappa=kmax*pow(10.,penalty_factor);
 
+
+		Input* thawed_element_input = basalelement->GetInput(HydrologydcMaskThawedEltEnum); _assert_(thawed_element_input);
+		thawed_element_input->GetInputValue(&thawed_element);
+
 		for(int i=0;i<numnodes;i++){
+			/*frozen elements heads are set to base elevation*/
+			if(!thawed_element){
+				values[i]=base[i];
+			}
 			GetHydrologyDCInefficientHmax(&h_max,basalelement,basalelement->GetNode(i));
 			if(values[i]>h_max) {
@@ -551,7 +562,6 @@
 				residual[i] = 0.;
 			}
-			//adding base in min to take into account heads under bed wich don't change N
-			//pressure[i]=(rho_ice*g*thickness[i])-(rho_freshwater*g*(max((min(h_max,values[i])-base[i]),0.0)));
 			pressure[i]=(rho_ice*g*thickness[i])-(rho_freshwater*g*(values[i]-base[i]));
+
 		}
 		xDelete<IssmDouble>(thickness);
@@ -575,10 +585,8 @@
 	}
 }/*}}}*/
-
 void HydrologyDCInefficientAnalysis::UpdateConstraints(FemModel* femmodel){/*{{{*/
 	/*Default, do nothing*/
 	return;
 }/*}}}*/
-
 IssmDouble HydrologyDCInefficientAnalysis::SedimentStoring(Element* element,Gauss* gauss,Input* sed_head_input, Input* base_input){/*{{{*/
 	int unconf_scheme;
@@ -620,5 +628,4 @@
 	return sediment_storing;
 }/*}}}*/
-
 IssmDouble HydrologyDCInefficientAnalysis::SedimentTransmitivity(Element* element,Gauss* gauss,Input* sed_head_input, Input* base_input,Input* SedTrans_input){/*{{{*/
 	int unconf_scheme;
@@ -630,7 +637,5 @@
 	IssmDouble base_elev,prestep_head,water_sheet;
 	IssmDouble sediment_thickness       = element->GetMaterialParameter(HydrologydcSedimentThicknessEnum);
-	bool isthermal;
-
-	element->FindParam(&isthermal,TransientIsthermalEnum);
+
 	element->FindParam(&unconf_scheme,HydrologydcUnconfinedFlagEnum);
 	SedTrans_input->GetInputValue(&FullLayer_transmitivity,gauss);
@@ -657,5 +662,4 @@
 	return sediment_transmitivity;
 }/*}}}*/
-
 void  HydrologyDCInefficientAnalysis::GetHydrologyDCInefficientHmax(IssmDouble* ph_max,Element* element, Node* innode){/*{{{*/
 
@@ -693,5 +697,4 @@
 }
 /*}}}*/
-
 IssmDouble HydrologyDCInefficientAnalysis::GetHydrologyKMatrixTransfer(Element* element){/*{{{*/
 
@@ -715,5 +718,4 @@
 	return transfer;
 }/*}}}*/
-
 IssmDouble HydrologyDCInefficientAnalysis::GetHydrologyPVectorTransfer(Element* element, Gauss* gauss, Input* epl_head_input){/*{{{*/
 
@@ -740,5 +742,4 @@
 	return transfer;
 }/*}}}*/
-
 void HydrologyDCInefficientAnalysis::ElementizeEplMask(FemModel* femmodel){/*{{{*/
 
@@ -759,6 +760,5 @@
 	}
 }/*}}}*/
-
-void  HydrologyDCInefficientAnalysis::HydrologyIDSGetMask(Vector<IssmDouble>* vec_mask, Element* element){
+void  HydrologyDCInefficientAnalysis::HydrologyIDSGetMask(Vector<IssmDouble>* vec_mask, Element* element){/*{{{*/
 	bool        active_element;
 	int         domaintype;
@@ -801,5 +801,5 @@
 	xDelete<IssmDouble>(meltingrate);
 	xDelete<IssmDouble>(groundedice);
-}
+}/*}}}*/
 void HydrologyDCInefficientAnalysis::ElementizeIdsMask(FemModel* femmodel){/*{{{*/
 
@@ -820,5 +820,4 @@
 	}
 }/*}}}*/
-
 void HydrologyDCInefficientAnalysis::HydrologyIdsGetActive(Vector<IssmDouble>* active_vec, Element* element){/*{{{*/
 	/*Constants*/
Index: issm/trunk/src/c/analyses/MasstransportAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/MasstransportAnalysis.cpp	(revision 23389)
+++ issm/trunk/src/c/analyses/MasstransportAnalysis.cpp	(revision 23394)
@@ -124,5 +124,4 @@
 	bool   isoceancoupling;
 	bool   issmb;
-	int    basalforcingsmodel;
 
 	/*Fetch data needed: */
@@ -133,5 +132,4 @@
 	iomodel->FindConstant(&isoceancoupling,"md.transient.isoceancoupling");
 	iomodel->FindConstant(&issmb,"md.transient.issmb");
-	iomodel->FindConstant(&basalforcingsmodel,"md.basalforcings.model");
 
 	/*Finite element type*/
@@ -158,9 +156,4 @@
 	iomodel->FetchDataToInput(elements,"md.mask.groundedice_levelset",MaskGroundediceLevelsetEnum);
 	iomodel->FetchDataToInput(elements,"md.basalforcings.groundedice_melting_rate",BasalforcingsGroundediceMeltingRateEnum);
-	if (basalforcingsmodel==SpatialLinearFloatingMeltRateEnum){
-		iomodel->FetchDataToInput(elements,"md.basalforcings.deepwater_melting_rate",BasalforcingsDeepwaterMeltingRateEnum);
-		iomodel->FetchDataToInput(elements,"md.basalforcings.deepwater_elevation",BasalforcingsDeepwaterElevationEnum);
-		iomodel->FetchDataToInput(elements,"md.basalforcings.upperwater_elevation",BasalforcingsUpperwaterElevationEnum);
-	}
 	iomodel->FetchDataToInput(elements,"md.initialization.vx",VxEnum);
 	iomodel->FetchDataToInput(elements,"md.initialization.vy",VyEnum);
@@ -181,4 +174,9 @@
 			break;
 		case MantlePlumeGeothermalFluxEnum:
+			break;
+		case SpatialLinearFloatingMeltRateEnum:
+			iomodel->FetchDataToInput(elements,"md.basalforcings.deepwater_melting_rate",BasalforcingsDeepwaterMeltingRateEnum);
+			iomodel->FetchDataToInput(elements,"md.basalforcings.deepwater_elevation",BasalforcingsDeepwaterElevationEnum);
+			iomodel->FetchDataToInput(elements,"md.basalforcings.upperwater_elevation",BasalforcingsUpperwaterElevationEnum);
 			break;
 		case BasalforcingsPicoEnum:
@@ -631,7 +629,7 @@
 }/*}}}*/
 void           MasstransportAnalysis::GetB(IssmDouble* B,Element* element,int dim,IssmDouble* xyz_list,Gauss* gauss){/*{{{*/
-	/*Compute B  matrix. B=[B1 B2 B3] where Bi is of size 3*NDOF2. 
+	/*Compute B  matrix. B=[B1 B2 B3] where Bi is of size 3*NDOF2.
 	 * For node i, Bi can be expressed in the actual coordinate system
-	 * by: 
+	 * by:
 	 *       Bi=[ N ]
 	 *          [ N ]
@@ -659,7 +657,7 @@
 }/*}}}*/
 void           MasstransportAnalysis::GetBprime(IssmDouble* Bprime,Element* element,int dim,IssmDouble* xyz_list,Gauss* gauss){/*{{{*/
-	/*Compute B'  matrix. B'=[B1' B2' B3'] where Bi' is of size 3*NDOF2. 
+	/*Compute B'  matrix. B'=[B1' B2' B3'] where Bi' is of size 3*NDOF2.
 	 * For node i, Bi' can be expressed in the actual coordinate system
-	 * by: 
+	 * by:
 	 *       Bi_prime=[ dN/dx ]
 	 *                [ dN/dy ]
Index: issm/trunk/src/c/analyses/SmbAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/SmbAnalysis.cpp	(revision 23389)
+++ issm/trunk/src/c/analyses/SmbAnalysis.cpp	(revision 23394)
@@ -5,4 +5,7 @@
 #include "../modules/modules.h"
 
+// FIX
+#include "./shared/io/Print/Print.h"
+
 /*Model processing*/
 void SmbAnalysis::CreateConstraints(Constraints* constraints,IoModel* iomodel){/*{{{*/
@@ -21,5 +24,5 @@
 
 	int    smb_model;
-	bool   isdelta18o,ismungsm,isd18opd,issetpddfac,isprecipscaled,istemperaturescaled;
+	bool   isdelta18o,ismungsm,isd18opd,issetpddfac,isprecipscaled,istemperaturescaled,isfirnwarming;
 
 	/*Update elements: */
@@ -35,5 +38,4 @@
 	/*Figure out smb model: */
 	iomodel->FindConstant(&smb_model,"md.smb.model");
-
 	switch(smb_model){
 		case SMBforcingEnum:
@@ -88,4 +90,14 @@
 			}
 			break;
+		case SMBpddSicopolisEnum:
+			iomodel->FetchDataToInput(elements,"md.smb.s0p",SmbS0pEnum);
+			iomodel->FetchDataToInput(elements,"md.smb.s0t",SmbS0tEnum);
+			iomodel->FindConstant(&isfirnwarming,"md.smb.isfirnwarming");
+			iomodel->FetchDataToInput(elements,"md.smb.smb_corr",SmbSmbCorrEnum);
+			iomodel->FetchDataToInput(elements,"md.smb.precipitation",SmbPrecipitationEnum);
+			iomodel->FetchDataToInput(elements,"md.smb.monthlytemperatures",SmbMonthlytemperaturesEnum);
+			iomodel->FetchDataToInput(elements,"md.smb.precipitation_anomaly",SmbPrecipitationsAnomalyEnum);
+			iomodel->FetchDataToInput(elements,"md.smb.temperature_anomaly",SmbTemperaturesAnomalyEnum);
+			break;
 		case SMBd18opddEnum:
 			iomodel->FindConstant(&istemperaturescaled,"md.smb.istemperaturescaled");
@@ -139,4 +151,10 @@
 			iomodel->FetchDataToInput(elements,"md.smb.refreeze",SmbRefreezeEnum,0.);
 			break;
+		case SMBgradientscomponentsEnum:
+			iomodel->FetchDataToInput(elements,"md.smb.accualti",SmbAccualtiEnum);
+			iomodel->FetchDataToInput(elements,"md.smb.accugrad",SmbAccugradEnum);
+			iomodel->FetchDataToInput(elements,"md.smb.runoffalti",SmbRunoffaltiEnum);
+			iomodel->FetchDataToInput(elements,"md.smb.runoffgrad",SmbRunoffgradEnum);
+			break;
 		default:
 			_error_("Surface mass balance model "<<EnumToStringx(smb_model)<<" not supported yet");
@@ -148,5 +166,5 @@
 	int     numoutputs;
 	char**  requestedoutputs = NULL;
-	bool    isdelta18o,ismungsm,isd18opd,issetpddfac,interp;
+	bool    isdelta18o,ismungsm,isd18opd,issetpddfac,interp,isfirnwarming;
 	int     smb_model;
 	IssmDouble *temp = NULL;
@@ -215,4 +233,7 @@
 			}
 			break;
+		case SMBpddSicopolisEnum:
+			parameters->AddObject(iomodel->CopyConstantObject("md.smb.isfirnwarming",SmbIsfirnwarmingEnum));
+			break;
 		case SMBd18opddEnum:
 			parameters->AddObject(iomodel->CopyConstantObject("md.smb.ismungsm",SmbIsmungsmEnum));
@@ -246,4 +267,18 @@
 			/*Nothing to add to parameters*/
 			break;
+		case SMBgradientscomponentsEnum:
+				parameters->AddObject(iomodel->CopyConstantObject("md.smb.accualti",SmbAccualtiEnum));
+				parameters->AddObject(iomodel->CopyConstantObject("md.smb.accugrad",SmbAccugradEnum));
+				parameters->AddObject(iomodel->CopyConstantObject("md.smb.runoffalti",SmbRunoffaltiEnum));
+				parameters->AddObject(iomodel->CopyConstantObject("md.smb.runoffgrad",SmbRunoffgradEnum));
+
+			  iomodel->FetchData(&temp,&N,&M,"md.smb.accuref"); _assert_(N==2);
+			  parameters->AddObject(new TransientParam(SmbAccurefEnum,&temp[0],&temp[M],interp,M));
+			  iomodel->DeleteData(temp,"md.smb.accuref");
+
+			  iomodel->FetchData(&temp,&N,&M,"md.smb.runoffref"); _assert_(N==2);
+			  parameters->AddObject(new TransientParam(SmbRunoffrefEnum,&temp[0],&temp[M],interp,M));
+			  iomodel->DeleteData(temp,"md.smb.runoffref");
+			break;
 		default:
 			_error_("Surface mass balance model "<<EnumToStringx(smb_model)<<" not supported yet");
@@ -280,11 +315,15 @@
 				if(VerboseSolution()) _printf0_("   call Delta18oParameterization module\n");
 				Delta18oParameterizationx(femmodel);
-			} 
+			}
 			if(ismungsm){
 				if(VerboseSolution()) _printf0_("   call MungsmtpParameterization module\n");
 				MungsmtpParameterizationx(femmodel);
-			} 
+			}
 			if(VerboseSolution()) _printf0_("   call positive degree day module\n");
 			PositiveDegreeDayx(femmodel);
+			break;
+		case SMBpddSicopolisEnum:
+			if(VerboseSolution()) _printf0_("   call SICOPOLIS positive degree day module\n");
+			PositiveDegreeDaySicopolisx(femmodel);
 			break;
 		case SMBd18opddEnum:
@@ -296,5 +335,5 @@
 				if(VerboseSolution()) _printf0_("   call positive degree day module\n");
 				PositiveDegreeDayx(femmodel);
-			} 
+			}
 			break;
 		case SMBgradientsEnum:
@@ -321,4 +360,8 @@
 			/*Nothing to be done*/
 			break;
+		case SMBgradientscomponentsEnum:
+			if(VerboseSolution())_printf0_("	call smb gradients components module\n");
+			SmbGradientsComponentsx(femmodel);
+			break;
 		default:
 			_error_("Surface mass balance model "<<EnumToStringx(smb_model)<<" not supported yet");
